=== debian/changelog ===
ros-galactic-magic-enum (0.8.1-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Neargye <neargye@gmail.com>  Mon, 12 Sep 2022 12:24:58 -0000
